<template>
    <div>
        <div class="d-md-flex align-items-center flex-wrap justify-content-center mt-4 p-3 pb-3 contenedorPrincipal">
            <label class="form-label mx-2">Estado:</label>
           <div class="col-2"> 
             <select class="form-label w-100" v-model="data.estado">
                <option selected :value="null">Todos</option>
                <option v-for="estado in data.estados" :value="estado">{{estado.d_estado}}</option>
            </select>
            </div>
            <button type="button" class="btn btn-principal px-2 mx-4" @click="busquedaCuentas()">
                <i class="bi bi-search"></i>
            </button>
        </div>

        <listado-cuentas :cuentas="data.cuentas" class="mt-2"></listado-cuentas>
    </div>
</template>

<script setup lang="ts">
// librerias
import http from "@/http";
import { reactive, watch , onMounted } from "vue";
import { loading, urlApi } from "@/shared.js";
// components
import ListadoCuentas from "@/components/Bapro/ConsultaCuentas/ListadoCuentas.vue"

// entities
import Estado from "@/entities/Bapro/ConsultaCuentas/Estado";
import Pedidodetalle from "@/entities/Bapro/PedidosCuenta/Pedidodetalle";

// store
defineEmits(['listadoCuentas'])

const data = reactive({
    estados: [] as Estado[],
    estado: {} as Estado,
    cuentas: [] as Pedidodetalle[]
});

onMounted(async () => {
    loading.show();

    const response = await http.request<Estado[]>({
        method: "GET",
        url: urlApi + "getEstadosBapro",
        transformResponse: [
          (data: string) => {
            const estados: Estado[] = JSON.parse(data);
            const estadosAux: Estado[] = [];
            estados.forEach((element: Estado) => {
                estadosAux.push(Object.assign(new Estado(), element));
            });
            return estadosAux;
          },
        ],
    });
    
    data.estados = response.data;

    loading.hide();
});

async function busquedaCuentas() {
    loading.show();
    
    const paramsRequest: any = {};
    paramsRequest.id_baproestado = (data.estado != null)? data.estado.id_baproestado : null;

    const response: AxiosResponse<Pedidodetalle[]> = await http.request<Pedidodetalle[]>({
        method: "GET",
        url: urlApi + "getCuentasBapro",
        params: paramsRequest,
        transformResponse: [
            (data: string) => {
                const archivoCuentas: Pedidodetalle[] = JSON.parse(data);
                const dataAux: Pedidodetalle[] = [];
                archivoCuentas.res.forEach((element: Pedidodetalle) => {
                    dataAux.push(Object.assign(new Pedidodetalle(), element));
                });
                return dataAux;
            }
        ],
    });

    data.cuentas = response.data;

    loading.hide();

}


</script>
